Bug 501308 - REGRESSION: iSCSI Target's Redirect login causes errors in connection
REGRESSION: iSCSI Target's Redirect login causes errors in connection
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
All Linux
low Severity medium
: rc
: ---
Assigned To: Mike Christie
Red Hat Kernel QE team
: Regression
Depends On:
  Show dependency treegraph
Reported: 2009-05-18 09:41 EDT by Mike Christie
Modified: 2009-09-02 05:00 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-09-02 05:00:11 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Mike Christie 2009-05-18 09:41:35 EDT
Description of problem:

From upstream thread:

When called with a consumed value that is less than skb_headlen(skb)
bytes into a page frag, skb_seq_read() incorrectly returns an
offset/length relative to skb->data. Ensure that data which should come
from a page frag does.

Seen in iSCSI testing:

We have seen this scenario affect iSCSI transactions(mainly login) with
BCM57710 10G Ethernet(bnx2x driver) card.

The iSCSI login errs because the iSCSI PDU header is wrongly read with a
wrong ITT value. This error in reading the PDU is seen with this card
because of the way the bnx2x driver pushes data to the frags with LRO
enabled (through skb->frags[n]).

Intel 10G(ixgbe driver) + LRO combination does not expose the issue and
the patch doesn't cause a regression either. I am not sure if this patch
will break other driver+card configurations.  

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
Actual results:

Expected results:

Additional info:

netdev thread.
Comment 1 Mike Christie 2009-05-18 09:45:50 EDT
Adding regression note, because in RHEL 5.3 iscsi_tcp did not use skb_seq_read. In 5.4 it now does.
Comment 2 RHEL Product and Program Management 2009-05-18 09:49:18 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
Comment 4 Shyam kumar Iyer 2009-06-08 05:11:35 EDT
The kernel fixes the issue. 

I did minimal regression testing with a 10G, BCM 57710, 1Gig BCM5721 and 10G Intel 82598 adapter.
Comment 5 Mike Christie 2009-06-08 11:35:53 EDT
Thanks for testing.
Comment 6 Don Zickus 2009-06-11 11:37:17 EDT
in kernel-2.6.18-153.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 9 errata-xmlrpc 2009-09-02 05:00:11 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.